#ifndef __SIX2CLIP_DEFINED
#define __SIX2CLIP_DEFINED

#include "six.ch"

#xdefine SETRDD             RDDSETDEFAULT

#xdefine SXCHAR				RMCHAR
#xdefine SXNUM				RMNUM
#xdefine SXDATE				RMDATE
#xdefine SXLOG				RMLOG

#xdefine SX_BLOB2FILE		RM_BLOB2FILE
#xdefine SX_CHILL			RM_CHILL
#xdefine SX_CLEARORDER		RM_CLEARORDER
#xdefine SX_DESCEND			RM_DESCEND
#xdefine SX_FILE2BLOB		RM_FILE2BLOB
#xdefine SX_FILEORDER		RM_FILEORDER
#xdefine SX_FNAMEPARSER		RM_FNAMEPARSER
#xdefine SX_FNAMEPA			RM_FNAMEPARSER
#xdefine SX_FREEZE			RM_FREEZE
#xdefine SX_I_INDEXNAME		RM_I_INDEXNAME
#xdefine SX_I_TAGNAME		RM_I_TAGNAME
#xdefine SX_INDEXCOUNT		RM_INDEXCOUNT
#xdefine SX_INDEXNAME		RM_INDEXNAME
#xdefine SX_INDEXTYPE		RM_INDEXTYPE
#xdefine SX_ISFLOCKED		RM_ISFLOCKED
#xdefine SX_ISLOCKED		RM_ISLOCKED
#xdefine SX_ISREADONLY		RM_ISREADONLY
#xdefine SX_ISREINDEX		RM_ISREINDEX
#xdefine SX_ISSHARED		RM_ISSHARED
#xdefine SX_KEYGOTO			RM_KEYGOTO
#xdefine SX_KEYSINCLUDED	RM_KEYSINCLUDED
#xdefine SX_KILLTAG			RM_KILLTAG
#xdefine SX_MEMOEXT			RM_MEMOEXT
#xdefine SX_MEMOPACK		RM_MEMOPACK
#xdefine SX_RLOCK			RM_RLOCK
#xdefine SX_ROLLBACK		RM_ROLLBACK
#xdefine SX_SEEKLAST		RM_SEEKLAST
#xdefine SX_SETFILEORD		RM_SETFILEORD
#xdefine SX_SETTAG			RM_SETTAG
#xdefine SX_SETTAGNO		RM_SETTAGNO
#xdefine SX_SETTAGORDER		RM_SETTAG
#xdefine SX_SETTRIGGER		RM_SETTRIGGER
#xdefine SX_SLIMFAST		RM_SLIMFAST
#xdefine SX_STEP			RM_STEP
#xdefine SX_TABLENAME		RM_TABLENAME
#xdefine SX_TABLETYPE		RM_TABLETYPE
#xdefine SX_TAGCOUNT		RM_TAGCOUNT
#xdefine SX_TAGINFO			RM_TAGINFO
#xdefine SX_TAGS			RM_TAGS
#xdefine SX_TAGNO			RM_TAGNO
#xdefine SX_TAGUNIQUE		RM_TAGUNIQUE
#xdefine SX_THERMOMETER		RM_THERMOMETER
#xdefine SX_VSIGLEN			RM_VSIGLEN
#xdefine SX_WARM			RM_WARM
#xdefine SX_WILDMATCH		RM_WILDMATCH
#xdefine SX_WILDSEEK		RM_WILDSEEK

#xdefine M6_NEWFILTER		RM_NEWFILTER
#xdefine M6_SETAREAFILTER   RM_SETAREAFILTER
#xdefine M6_GETAREAFILTER   RM_GETAREAFILTER
#xdefine M6_FREEFILTER      RM_FREEFILTER
#xdefine M6_FILTADDREC      RM_FILTADDREC
#xdefine M6_FILTDROPREC     RM_FILTDROPREC
#xdefine M6_FILTCHGREC      RM_FILTCHGREC
#xdefine M6_ISFILTER        RM_ISFILTER
#xdefine M6_FILTJOIN        RM_FILTJOIN
#xdefine M6_EVALPARTIAL     RM_EVALPARTIAL
#xdefine M6_FILTINVERSE     RM_FILTINVERSE
#xdefine M6_FILTCOPY        RM_FILTCOPY
#xdefine M6_FILTINFO        RM_FILTINFO
#xdefine M6_FILTCOUNT       RM_FILTCOUNT
#xdefine M6_ISFILTREC       RM_ISFILTREC

#xdefine SX_AUTOOPEN(bMode)			SET(_SET_AUTOPEN,bMode)
#xdefine SX_AUTOSHARE(nMod)			SET(_SET_AUTOSHARE,nMod)
#xdefine SX_CLRSCOPE(which)			ORDSCOPE(which,NIL)
#xdefine SX_DBCREATE				DBCREATE
#xdefine SX_DTOP(x)    				x
#xdefine SX_GETLOCKS				DBRLOCKLIST
#xdefine SX_INDEXFILTER				ORDFOR
#xdefine SX_ISDBT()					.F.
#xdefine SX_KEYADD     				ORDKEYADD
#xdefine SX_KEYCOUNT				ORDKEYCOUNT
#xdefine SX_KEYDATA    				ORDKEYVAL
#xdefine SX_KEYDROP    				ORDKEYDEL
#xdefine SX_KEYSKIP    				DBSKIP
#xdefine SX_KEYNO					ORDKEYNO
#xdefine SX_PTOD(x)    				x
#xdefine SX_SETSCOPE				ORDSCOPE
#xdefine SX_SKIPUNIQUE				ORDSKIPUNIQUE
#xdefine SX_TAGNAME    				ORDNAME
#xdefine SX_TAGORDER				ORDNUMBER
#xdefine SX_VFGET(expr,len)			PADR(&(expr),len)

#xtranslate SX_SETMEMOBLOCK([<x>])      =>	;
		SET(_SET_MBLOCKSIZE,<x>)

#command PACK                   => __dbPack(); rm_MemoPack()

#command MEMOPACK [BLOCK <size>] [OPTION <opt>] [STEP <step>]       ;
	=> rm_MemoPack(<size>,<{opt}>,<step>)

#command USE <(db)>                                                 ;
		 [VIA <rdd>]                                                ;
		 [ALIAS <a>]                                                ;
		 [<new: NEW>]                                               ;
		 [<ex: EXCLUSIVE>]                                          ;
		 [<sh: SHARED>]                                             ;
		 [<ro: READONLY>]                                           ;
		 [<tmp: TEMPORARY>]                                         ;
		 [INDEX <(index1)> [, <(indexn)>]]                          ;
		 [TRIGGER <trig>]                                           ;
																	;
	  => dbUseArea(                                                 ;
			<.new.>, <rdd>, <(db)>, <(a)>,                          ;
			iif(<.sh.> .or. <.ex.>, !<.ex.>, NIL), <.ro.>,<.tmp.>   ;
		  )                                                         ;
		 ; rm_setTrigger(TRIGGER_INSTALL,<trig>)                    ;
																	;
	  [; dbSetIndex( <(index1)> )]                                  ;
	  [; dbSetIndex( <(indexn)> )]

#xcommand WILDSEEK <str>                                            ;
	=> rm_WildSeek( <str> )

#xcommand WILDSEEKNEXT <str>                                        ;
	=> rm_WildSeek( <str>, .T. )

#command SET TAGORDER TO <order>                                    ;
	  => ordSetFocus( <order> )

#command SET TAGORDER TO                                            ;
	  => ordSetFocus( 0 )

#command SET TAG TO <tag> [OF <(cdx)>]                                     ;
	  => ordSetFocus( <(tag)> [, <(cdx)>] )

#command SET TAG TO                                                        ;
	  => ordSetFocus( 0 )

#command REINDEX                                                    ;
		[EVAL   <opt> [EVERY <step>]]                               ;
		[OPTION <opt> [STEP  <step>]]                               ;
	  => ordCondSet(,,,, <{opt}>, <step>,,,,,,,,,,)                 ;
	   ; dbReindex()

#endif

